package com.example.separation.contactimport;

import com.example.separation.contactimport.R;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class ContactImportActivity extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
		Button buttonUninstall = (Button) findViewById(R.id.buttonUninstall);
        buttonUninstall.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				//uninstallしますか？　みたいに聞いてアプリケーション管理の画面へ飛ばす
				String packageName = getPackageName(); //"com.example.separation.contactimport";
				showUninstallButton(packageName);
			}
		});
		Button buttonClose = (Button) findViewById(R.id.buttonClose);
		buttonClose.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				finish();
			}
		});
	}

    /**
     * http://hascha.blogspot.jp/2012/04/blog-post.html
     * @param packageName
     */
	private void showUninstallButton(String packageName) {
		Intent intent = new Intent();
		if (Build.VERSION.SDK_INT > 8) {
			intent.setAction("android.settings.APPLICATION_DETAILS_SETTINGS");
			Uri uri = Uri.fromParts("package", packageName, null);
			intent.setData(uri);
		} else {
			String appPkgName;
			if (Build.VERSION.SDK_INT == 8) {
				appPkgName = "pkg";
			} else {
				appPkgName = "com.android.settings.ApplicationPkgName";
			}
			intent.setAction(Intent.ACTION_VIEW);
			intent.setClassName("com.android.settings", "com.android.settings.InstalledAppDetails");
			intent.putExtra(appPkgName, packageName);
		}
		startActivity(intent);
	}
}