package com.example.separation.contactimport;

import java.util.ArrayList;
import java.util.List;

import org.jssec.android.shared.PkgCert;
import org.jssec.android.shared.PkgCertWhitelists;
import org.jssec.android.shared.SigPerm;
import org.jssec.android.shared.Utils;

import com.example.separation.contactimport.R;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class ContactImportPickActivity extends Activity {
    private ArrayList<Nyanyan> listItems;
	private final static String ACCESS_PERMISSION = "com.example.separation.contactimport.access";

	// ★ポイント2★ 利用元アプリの証明書がホワイトリストに登録されていることを確認する
	private static PkgCertWhitelists sWhitelists = null;
	private static void buildWhitelists(Context context) {
		//boolean isdebug = Utils.isDebuggable(context);
		sWhitelists = new PkgCertWhitelists();
		
		//(android:protectionLevel="signature"なので自社アプリ（＝このアプリと同じ署名）のみホワイトリストへ)

		String selfHash = PkgCert.hash(context, context.getPackageName());
		
		// 自社アプリ 達 の証明書ハッシュ値を登録
		//sWhitelists.add("com.example.separation.contactimport", selfHash);
		sWhitelists.add("com.example.separation.hakudatsu", selfHash);
		// ↑「debug云々のくだりは各アプリ毎にチェックすべきで、自アプリだけdebugだから他もDebugっておかしくね？」と思ったので省略
		// ↑でもってなおかつ、[悪質な勝手マーケット／リソース書き換えアプリ]等で*再署名*される事態を切り捨てて良いなら、自分のアプリと署名が一致かだけでOK、という手抜き。
		// 再署名を排除するなら、厳密なフィンガープリントを登録
		
		// パートナーアプリ 達の証明書ハッシュ値を登録
		// android:protectionLevel="signature"だったら登録する事は無い
		
	}
	private static boolean checkPartner(Context context, String pkgname) {
		if (sWhitelists == null) buildWhitelists(context);
		return sWhitelists.test(context, pkgname);
	}

//	// 自社の証明書のハッシュ値
//	private static String sMyCertHash = null;
//	private static String myCertHash(Context context) {
//		if (sMyCertHash == null) {
//			if (Utils.isDebuggable(context)) {
//				// debug.keystoreの"androiddebugkey"の証明書ハッシュ値
//				sMyCertHash = "0EFB7236 328348A9 89718BAD DF57F544 D5CCB4AE B9DB34BC 1E29DD26 F77C8255";
//			} else {
//				// keystoreの"my company key"の証明書ハッシュ値
//				sMyCertHash = "D397D343 A5CBC10F 4EDDEB7C A10062DE 5690984F 1FB9E88B D7B3A7C2 42E142CA";
//			}
//		}
//		return sMyCertHash;
//	}

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.contactimportpickactivity);

//		// ★ポイントX★ アプリケーションが第三者に再署名されていないかを確認する
//		if (!PkgCert.hash(this, this.getPackageName()).equals(myCertHash(this))) {
//			Toast.makeText(this, "アプリケーションが第三者に再署名されているので起動出来ません。", Toast.LENGTH_LONG).show();
//			setResult(RESULT_CANCELED);
//			finish();
//			return;
//		}
        
        // ★ポイント2★ 利用元アプリの証明書がホワイトリストに登録されていることを確認する
        if (!checkPartner(this, getCallingPackage())) {
			Toast.makeText(this, "利用元アプリはアクセス許可したアプリではない。", Toast.LENGTH_LONG).show();
			setResult(RESULT_CANCELED);
			finish();
			return;
		}
        
        // 呼び出し元パッケージ名をチェックしないなら、↓の手抜きで十分
//		// ★ポイント2'★ 利用元アプリの証明書がこのアプリと同じか確認する
//		if (!(pm.checkSignatures(this.getPackageName(), getCallingPackage()) == PackageManager.SIGNATURE_MATCH)) {
//			Toast.makeText(this, "利用元アプリはアクセス許可したアプリではない。", Toast.LENGTH_LONG).show();
//			setResult(RESULT_CANCELED);
//			finish();
//			return;
//		}

//		// ★ポイント4★ 独自定義Signature Permissionが自社アプリにより定義されていることを確認する
//		if (!SigPerm.test(this, ACCESS_PERMISSION, myCertHash(this))) {
//			Toast.makeText(this, "独自定義Signature Permissionが自社アプリにより定義されていない。", Toast.LENGTH_LONG).show();
//			setResult(RESULT_CANCELED);
//			finish();
//			return;
//		}
		// 権限が無い場合もあるので…JSSECの↑はそのまま使えない。あとsignature permissionは署名が同じかチェックとなるので利用元アプリのチェックを★ポイント2★で完了してると言い張っても良いはずだ！（つまり手抜き）
        

		// ★ポイント5★ 自社アプリからのIntentであっても、受信Intentの安全性を確認する
		// ……特に受け取るIntent無し
    	
		Button buttonOk = (Button)findViewById(R.id.buttonOk);
        buttonOk.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Intent intent = new Intent();
				StringBuilder sb = new StringBuilder();
				for (int i = 0; i < listItems.size(); i++) {
					Nyanyan nyanyan = listItems.get(i);
					if (nyanyan.isTarget){
						sb.append(nyanyan.getNumber());
						sb.append("\n");
					}
				}
				
				intent.putExtra("importdata", sb.toString());
				setResult(RESULT_OK, intent);
				finish();
			}
		});
        
        Button buttonCancel = (Button)findViewById(R.id.buttonCancel);
        buttonCancel.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				setResult(RESULT_CANCELED);
				finish();return;
			}
		});
        
		TextView textViewImportInfo = (TextView)findViewById(R.id.textViewImportInfo);
		textViewImportInfo.setText("インポートしたい電話番号にチェックしてOKを押してね！");
		
		
		ListView lv = (ListView)findViewById(R.id.listView1);
		listItems = new ArrayList<Nyanyan>();
		createArrayList(listItems, Build.VERSION.SDK_INT);
		NyanyanAdapter adapter = new NyanyanAdapter(this, listItems);
		lv.setAdapter(adapter);	
		
		
    }

	private void createArrayList(ArrayList<Nyanyan> listItems, int apiver) {
		if (apiver <= android.os.Build.VERSION_CODES.DONUT) {// ←1.6ね
			createArrayListForIS01(listItems);
		} else {
			createArrayListForNormal(listItems);
		}
	}
	
	private void createArrayListForIS01(ArrayList<Nyanyan> listItems) {
		Uri contentUri = android.provider.Contacts.Phones.CONTENT_URI;
		Cursor cursor = getContentResolver().query(contentUri, null,
				null, null, null);

		if (cursor.moveToFirst()) {
			do {
				String column_display_name = android.provider.Contacts.Phones.DISPLAY_NAME;
				String column_number = android.provider.Contacts.Phones.NUMBER;
				Nyanyan n = new Nyanyan();
				n.setTarget(false);
				n.setDisplayName(cursor.getString(cursor.getColumnIndex(column_display_name)));
				n.setNumber(cursor.getString(cursor.getColumnIndex(column_number)));
				listItems.add(n);
			} while (cursor.moveToNext());
		}
		cursor.close();
	}
	
	private void createArrayListForNormal(ArrayList<Nyanyan> listItems) {
		Uri contentUri = Uri.parse("content://com.android.contacts/data/phones"); //android.provider.ContactsContract.CommonDataKinds.Phone.CONTENT_URI
		Cursor cursor = getContentResolver().query(contentUri, null,
				null, null, null);

		if (cursor.moveToFirst()) {
			do {
				String column_display_name = "display_name"; //android.provider.ContactsContract.CommonDataKinds.Phone.DISPLAY_NAME;
				String column_number = "data1"; //android.provider.ContactsContract.CommonDataKinds.Phone.NUMBER;;
				Nyanyan n = new Nyanyan();
				n.setTarget(false);
				n.setDisplayName(cursor.getString(cursor.getColumnIndex(column_display_name)));
				n.setNumber(cursor.getString(cursor.getColumnIndex(column_number)));
				listItems.add(n);
			} while (cursor.moveToNext());
		}
		cursor.close();
	}
    
	public class Nyanyan {
    	private boolean isTarget = false;
    	private String displayName = null;
		private String number = null;
		public boolean isTarget() {
			return isTarget;
		}
		public void setTarget(boolean isTarget) {
			this.isTarget = isTarget;
		}
		public String getDisplayName() {
			return displayName;
		}
		public void setDisplayName(String name) {
			this.displayName = name;
		}
		public String getNumber() {
			return number;
		}
		public void setNumber(String number) {
			this.number = number;
		}
    }
	
	
	public class NyanyanAdapter extends ArrayAdapter<Nyanyan> {
		
		public NyanyanAdapter(Context context, List<Nyanyan> objects) {
			super(context, 0, objects);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;
			if (v == null){
				LayoutInflater inflater = (LayoutInflater) parent.getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = inflater.inflate(R.layout.listrow, null); //ViewGroup root の指定、nullでええん？
			}
			final Nyanyan nyanyan = getItem(position);
			if (nyanyan != null) {
				CheckBox checkBox1 = (CheckBox)v.findViewById(R.id.checkBox1);
				TextView textViewDisplayName = (TextView)v.findViewById(R.id.textViewDisplayName);
				TextView textViewNumber = (TextView)v.findViewById(R.id.textViewNumber);
				checkBox1.setChecked(nyanyan.isTarget());
				checkBox1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
					
					@Override
					public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
						nyanyan.setTarget(isChecked);
					}
				});
				textViewDisplayName.setText(nyanyan.getDisplayName());
				textViewNumber.setText(nyanyan.getNumber());
			}
			return v;
		}

	}
}
